// This file is part of Awali.
// Copyright 2016-2020 Sylvain Lombardy, Victor Marsault, Jacques Sakarovitch
//
// Awali is a free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef DYN_BASIC_WEIGHTSET_HH
#define DYN_BASIC_WEIGHTSET_HH

#include <awali/dyn/core/context-description/weightsets/abstract-weightset.hh>
#include <awali/sttc/misc/json.hh>

namespace awali {
namespace dyn {
namespace context {

    struct basic_weightset : abstract_weightset {
    private:
      const std::string public_name;
      const std::string class_name;
    public:
      basic_weightset(const std::string& public_name, const std::string& class_name) : public_name(public_name), class_name(class_name) {}

      const std::string& tostring(weightset_description ws, bool dynamic) const override
      {
        return class_name;
      }

  inline
  const std::string& static_public_name() const override{
    return public_name;
  }

      //Returns an empty shared pointer if the string does not correspond to the weightset
    weightset_description fromstring(const std::string &k) const override;

      inline
      weightset_description parse_weightset(js_object* p) const override {
        	return fromstring(p->str("semiring"));
      }

    };


}}} //end of namespaces awali::dyn::context, awali::dyn, and awali

#endif // DYN_BASIC_WEIGHTSET_HH
