#include<awali/sttc/automaton.hh>
#include<awali/sttc/algos/js_print.hh>
//#include<awali/sttc/algos/is-sequential.hh>
#include<awali/sttc/algos/min_quotient.hh>
#include<awali/sttc/algos/proper.hh>
#include<awali/sttc/algos/is-of-finite-image.hh>
#include<awali/sttc/ctx/law_char.hh>
#include<awali/sttc/algos/letterize-tape.hh>
#include <awali/sttc/misc/add-epsilon-trans.hh> // is_epsilon

using namespace awali::sttc;

template<typename T>
struct AFF {};

template<typename T>
void print_aff(const T& t) {AFF<T>::print();};


int main() {
  auto tdc=make_transducer<b>({'a','b'},{'x','y'});
  unsigned b=tdc->add_state();
  unsigned f=tdc->add_state();
  unsigned i=tdc->add_state();
  unsigned a=tdc->add_state();
  tdc->set_initial(i);
  tdc->set_final(f);
  tdc->new_transition(i,a,{'a','y'});
  tdc->new_transition(a,i,{'a','y'});
  tdc->new_transition(i,f,{'a','y'});
  tdc->new_transition(a,b,{'a','y'});
  tdc->new_transition(b,f,tdc->labelset()->one());
  tdc->new_transition(f,b,tdc->labelset()->one());
  js_print(tdc, std::cout,true) << std::endl;
  using labelset_t =  labelset_t_of<decltype(*tdc)>::valueset_t<1>;
  labelset_t lb((*tdc->labelset()).set<1>());

  tdc->new_transition(a,a,{lb.one(),'x'});

  std::cout << is_of_finite_image<0>(tdc) << std::endl;

  /*
  auto pdc = proper(tdc);
  js_print(pdc, std::cout,true) << std::endl;
  */

  auto tdclw = make_shared_ptr<mutable_automaton<context<ctx::lat<ctx::lal_char,ctx::law_char>,awali::sttc::b>>>
    (context<ctx::lat<ctx::lal_char,ctx::law_char>,awali::sttc::b>(std::make_tuple(ctx::lal_char({'a','b'}), ctx::law_char({'x','y'})),awali::sttc::b()));

  unsigned s1=tdclw->add_state();
  unsigned s2=tdclw->add_state();
  unsigned s3=tdclw->add_state();
  unsigned s4=tdclw->add_state();
  tdclw->set_initial(s1);
  tdclw->set_final(s4);
  tdclw->new_transition(s1,s2,{'a',""});
  tdclw->new_transition(s2,s3,{'b',"x"});
  tdclw->new_transition(s3,s4,{'a',"yx"});
  js_print(tdclw, std::cout,true) << std::endl;

  std::cerr << "Hop" << std::endl;

  auto tdcsub = letterize_tape<1>(tdclw);
  std::cerr << "Hop" << std::endl;
  js_print(tdcsub, std::cout,true) << std::endl;
  
  std::cerr << "Hop" << std::endl;


  
  //AFF<decltype(tdc->context().labelset()->set<1>())::print();
  
  //std::cout << is_func(tdc) << std::endl;

  //print_aff(tdc->labelset());
  
  /*
  sequential_tester<decltype(tdc)> st(tdc);
  st.compute_scc();
  for(auto p: tdc->states())
    std::cout << p << " in " << st.scc_of[p] << std::endl;
  for(unsigned i=0; i< st.strongly_con_comp.size(); ++i) {
    std::cout << i << " : ";
    for(auto p: st.strongly_con_comp[i])
      std::cout << p << ' ';
    std::cout << std::endl;
  }
  */
  //test_zero_comp(tdc);
  /*
  std::vector<std::list<unsigned> > equiv;
  hopcroft_quotient(tdc, equiv);
  tdc = merge(tdc, equiv);
  */
  return 0;
}
